Update One Metric Integration

PUT /api/atlas/v2/groups/{groupId}/metricIntegrations/{metricIntegrationId}

Updates the configuration for one metric integration identified by its unique ID.

Role requirements
  • Project Owner

Path parameters

  • groupId string Required

    Unique 24-hexadecimal digit string that identifies your project. Use the /groups endpoint to retrieve all projects to which the authenticated user has access.

    NOTE: Groups and projects are synonymous terms. Your group id is the same as your project id. For existing groups, your group/project id remains the same. The resource and corresponding endpoints use the term groups.

    Format should match the following pattern: ^([a-f0-9]{24})$.

  • metricIntegrationId string Required

    Unique identifier of the metric integration configuration.

Query parameters

  • envelope boolean

    Flag that indicates whether Application wraps the response in an envelope JSON object. Some API clients cannot access the HTTP response headers or status code. To remediate this, set envelope=true in the query. Endpoints that return a list of results use the results object as an envelope. Application adds the status parameter to the response body.

    Default value is false.

  • pretty boolean

    Flag that indicates whether the response body should be in the prettyprint format.

    Default value is false.

    Prettyprint
application/vnd.atlas.2025-03-12+json

Body Required

Updated metric integration configuration.

  • aggregationTemporality string Required

    The temporality to send to the metric integration.

    Values are DELTA or CUMULATIVE.

  • authType string Required

    Authentication method the integration uses when exporting metrics to the endpoint. HEADER authenticates with the static HTTP headers provided in the headers field, which must be set when this value is used.

    Value is HEADER.

  • endpoint string Required

    OpenTelemetry collector endpoint URL. Must use HTTPS.

    Maximum length is 2048.

  • headers array[object]

    HTTP headers for authentication and configuration. Total size limit 2KB. Required when authType is HEADER.

    At least 1 but not more than 10 elements.

    Hide headers attributes Show headers attributes object

    HTTP header with name and value.

    • name string Required

      Header name.

    • value string(password) Required

      Header value.

  • integrationType string Required

    Type of metric integration. Identifies which protocol will be used for the integration. This value cannot be modified after the integration is created.

    Value is OTEL.

  • metricSelection array[string] Required

    Array of metric categories to export. Determines which types of metrics are sent to the integration.

    At least 1 but not more than 30 elements. Values are ATLAS_STREAM_PROCESSING, MONGODB_METRICS, or HARDWARE_METRICS.

  • providerType string Required

    The provider type for the metric integration. Identifies the third-party service provider.

    Values are CUSTOM, DYNATRACE, or NEW_RELIC.

Responses

  • 200 application/vnd.atlas.2025-03-12+json

    OK

    Hide headers attributes Show headers attributes
    • RateLimit-Limit

      The maximum number of requests that a user can make within a specific time window.

    • RateLimit-Remaining

      The number of requests remaining in the current rate limit window before the limit is reached.

    Hide response attributes Show response attributes object
    • aggregationTemporality string Required

      The temporality to send to the metric integration.

      Values are DELTA or CUMULATIVE.

    • authType string Required

      Authentication method the integration uses when exporting metrics to the endpoint.

      Value is HEADER.

    • endpoint string Required

      OpenTelemetry collector endpoint URL.

      Maximum length is 2048.

    • headersRedacted array[object]

      HTTP headers for authentication and configuration. Values are redacted and never returned in plaintext.

      At least 1 but not more than 10 elements.

      Hide headersRedacted attributes Show headersRedacted attributes object

      HTTP header with a redacted value.

      • name string Required

        Header name.

      • value string Required

        Redacted header value.

    • integrationType string Required

      Type of metric integration. Identifies which protocol will be used for the integration.

      Value is OTEL.

    • metricIntegrationId string Required

      Unique identifier of the metric integration configuration.

      Minimum length is 24, maximum length is 24.

    • metricSelection array[string] Required

      Array of metric categories to export. Determines which types of metrics are sent to the integration.

      At least 1 but not more than 30 elements. Values are ATLAS_STREAM_PROCESSING, MONGODB_METRICS, or HARDWARE_METRICS.

    • providerType string Required

      The provider type for the metric integration. Identifies the third-party service provider.

      Values are CUSTOM, DYNATRACE, or NEW_RELIC.

  • 400 application/json

    Bad Request.

    Hide response attributes Show response attributes object
    • badRequestDetail object | null

      Bad request detail.

      Hide badRequestDetail attribute Show badRequestDetail attribute object | null
      • fields array[object]

        Describes all violations in a client request.

        Hide fields attributes Show fields attributes object
        • description string Required

          A description of why the request element is bad.

        • field string Required

          A path that leads to a field in the request body.

    • detail string | null

      Describes the specific conditions or reasons that cause each type of error.

    • error integer(int32) Required

      HTTP status code returned with this error.

      External documentation
    • errorCode string Required

      Application error code returned with this error.

    • parameters array[object]

      Parameters used to give more information about the error.

    • reason string | null

      Application error message returned with this error.

  • 401 application/json

    Unauthorized.

    Hide response attributes Show response attributes object
    • badRequestDetail object | null

      Bad request detail.

      Hide badRequestDetail attribute Show badRequestDetail attribute object | null
      • fields array[object]

        Describes all violations in a client request.

        Hide fields attributes Show fields attributes object
        • description string Required

          A description of why the request element is bad.

        • field string Required

          A path that leads to a field in the request body.

    • detail string | null

      Describes the specific conditions or reasons that cause each type of error.

    • error integer(int32) Required

      HTTP status code returned with this error.

      External documentation
    • errorCode string Required

      Application error code returned with this error.

    • parameters array[object]

      Parameters used to give more information about the error.

    • reason string | null

      Application error message returned with this error.

  • 403 application/json

    Forbidden.

    Hide response attributes Show response attributes object
    • badRequestDetail object | null

      Bad request detail.

      Hide badRequestDetail attribute Show badRequestDetail attribute object | null
      • fields array[object]

        Describes all violations in a client request.

        Hide fields attributes Show fields attributes object
        • description string Required

          A description of why the request element is bad.

        • field string Required

          A path that leads to a field in the request body.

    • detail string | null

      Describes the specific conditions or reasons that cause each type of error.

    • error integer(int32) Required

      HTTP status code returned with this error.

      External documentation
    • errorCode string Required

      Application error code returned with this error.

    • parameters array[object]

      Parameters used to give more information about the error.

    • reason string | null

      Application error message returned with this error.

  • 404 application/json

    Not Found.

    Hide response attributes Show response attributes object
    • badRequestDetail object | null

      Bad request detail.

      Hide badRequestDetail attribute Show badRequestDetail attribute object | null
      • fields array[object]

        Describes all violations in a client request.

        Hide fields attributes Show fields attributes object
        • description string Required

          A description of why the request element is bad.

        • field string Required

          A path that leads to a field in the request body.

    • detail string | null

      Describes the specific conditions or reasons that cause each type of error.

    • error integer(int32) Required

      HTTP status code returned with this error.

      External documentation
    • errorCode string Required

      Application error code returned with this error.

    • parameters array[object]

      Parameters used to give more information about the error.

    • reason string | null

      Application error message returned with this error.

  • 429 application/json

    Too Many Requests.

    Hide headers attributes Show headers attributes
    • RateLimit-Limit

      The maximum number of requests that a user can make within a specific time window.

    • RateLimit-Remaining

      The number of requests remaining in the current rate limit window before the limit is reached.

    • Retry-After

      The minimum time you should wait, in seconds, before retrying the API request. This header might be returned for 429 or 503 error responses.

    Hide response attributes Show response attributes object
    • badRequestDetail object | null

      Bad request detail.

      Hide badRequestDetail attribute Show badRequestDetail attribute object | null
      • fields array[object]

        Describes all violations in a client request.

        Hide fields attributes Show fields attributes object
        • description string Required

          A description of why the request element is bad.

        • field string Required

          A path that leads to a field in the request body.

    • detail string | null

      Describes the specific conditions or reasons that cause each type of error.

    • error integer(int32) Required

      HTTP status code returned with this error.

      External documentation
    • errorCode string Required

      Application error code returned with this error.

    • parameters array[object]

      Parameters used to give more information about the error.

    • reason string | null

      Application error message returned with this error.

  • 500 application/json

    Internal Server Error.

    Hide response attributes Show response attributes object
    • badRequestDetail object | null

      Bad request detail.

      Hide badRequestDetail attribute Show badRequestDetail attribute object | null
      • fields array[object]

        Describes all violations in a client request.

        Hide fields attributes Show fields attributes object
        • description string Required

          A description of why the request element is bad.

        • field string Required

          A path that leads to a field in the request body.

    • detail string | null

      Describes the specific conditions or reasons that cause each type of error.

    • error integer(int32) Required

      HTTP status code returned with this error.

      External documentation
    • errorCode string Required

      Application error code returned with this error.

    • parameters array[object]

      Parameters used to give more information about the error.

    • reason string | null

      Application error message returned with this error.

PUT /api/atlas/v2/groups/{groupId}/metricIntegrations/{metricIntegrationId}
atlas api metricIntegrations updateGroupMetricIntegration --help
import (
	"os"
	"context"
	"log"
	sdk "go.mongodb.org/atlas-sdk/v20250312001/admin"
)

func main() {
	ctx := context.Background()
	clientID := os.Getenv("MONGODB_ATLAS_CLIENT_ID")
	clientSecret := os.Getenv("MONGODB_ATLAS_CLIENT_SECRET")

	// See https://dochub.mongodb.org/core/atlas-go-sdk-oauth
	client, err := sdk.NewClient(sdk.UseOAuthAuth(clientID, clientSecret))

	if err != nil {
		log.Fatalf("Error: %v", err)
	}

	params = &sdk.UpdateGroupMetricIntegrationApiParams{}
	sdkResp, httpResp, err := client.MetricIntegrationsApi.
		UpdateGroupMetricIntegrationWithParams(ctx, params).
		Execute()
}
curl --include --header "Authorization: Bearer ${ACCESS_TOKEN}" \
  --header "Accept: application/vnd.atlas.2025-03-12+json" \
  --header "Content-Type: application/json" \
  -X PUT "https://cloud.mongodb.com/api/atlas/v2/groups/{groupId}/metricIntegrations/{metricIntegrationId}" \
  -d '{ <Payload> }'
curl --user "${PUBLIC_KEY}:${PRIVATE_KEY}" \
  --digest --include \
  --header "Accept: application/vnd.atlas.2025-03-12+json" \
  --header "Content-Type: application/json" \
  -X PUT "https://cloud.mongodb.com/api/atlas/v2/groups/{groupId}/metricIntegrations/{metricIntegrationId}" \
  -d '{ <Payload> }'
Request examples
{
  "aggregationTemporality": "DELTA",
  "authType": "HEADER",
  "endpoint": "https://otel-collector.example.com:4318/v1/metrics",
  "headers": [
    {
      "name": "Authorization",
      "value": "Bearer token123"
    }
  ],
  "integrationType": "OTEL",
  "metricSelection": [
    "ATLAS_STREAM_PROCESSING"
  ],
  "providerType": "CUSTOM"
}
Response examples (200)
# Headers

# Payload
{
  "aggregationTemporality": "DELTA",
  "authType": "HEADER",
  "endpoint": "https://otel-collector.example.com:4318/v1/metrics",
  "headersRedacted": [
    {
      "name": "Authorization",
      "value": "********oken"
    }
  ],
  "integrationType": "OTEL",
  "metricIntegrationId": "507f1f77bcf86cd799439011",
  "metricSelection": [
    "ATLAS_STREAM_PROCESSING"
  ],
  "providerType": "CUSTOM"
}
Response examples (400)
{
  "detail": "(This is just an example, the exception may not be related to this endpoint) No provider AWS exists.",
  "error": 400,
  "errorCode": "VALIDATION_ERROR",
  "reason": "Bad Request"
}
Response examples (401)
{
  "detail": "(This is just an example, the exception may not be related to this endpoint)",
  "error": 401,
  "errorCode": "NOT_ORG_GROUP_CREATOR",
  "reason": "Unauthorized"
}
Response examples (403)
{
  "detail": "(This is just an example, the exception may not be related to this endpoint)",
  "error": 403,
  "errorCode": "CANNOT_CHANGE_GROUP_NAME",
  "reason": "Forbidden"
}
Response examples (404)
{
  "detail": "(This is just an example, the exception may not be related to this endpoint) Cannot find resource AWS",
  "error": 404,
  "errorCode": "RESOURCE_NOT_FOUND",
  "reason": "Not Found"
}
Response examples (429)
{
  "detail": "(This is just an example, the exception may not be related to this endpoint)",
  "error": 429,
  "errorCode": "RATE_LIMITED",
  "reason": "Too Many Requests"
}
Response examples (500)
{
  "detail": "(This is just an example, the exception may not be related to this endpoint)",
  "error": 500,
  "errorCode": "UNEXPECTED_ERROR",
  "reason": "Internal Server Error"
}